<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_VisaOption ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_VisaOption extends AbstractStructArrayBase
{
    /**
     * The VisaOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_VisaOption[]
     */
    public $VisaOption;
    /**
     * Constructor method for ArrayOfJP_VisaOption
     * @uses ArrayOfJP_VisaOption::setVisaOption()
     * @param \StructType\JP_VisaOption[] $visaOption
     */
    public function __construct(array $visaOption = array())
    {
        $this
            ->setVisaOption($visaOption);
    }
    /**
     * Get VisaOption value
     * @return \StructType\JP_VisaOption[]|null
     */
    public function getVisaOption()
    {
        return $this->VisaOption;
    }
    /**
     * This method is responsible for validating the values passed to the setVisaOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVisaOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVisaOptionForArrayConstraintsFromSetVisaOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_VisaOptionVisaOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_VisaOptionVisaOptionItem instanceof \StructType\JP_VisaOption) {
                $invalidValues[] = is_object($arrayOfJP_VisaOptionVisaOptionItem) ? get_class($arrayOfJP_VisaOptionVisaOptionItem) : sprintf('%s(%s)', gettype($arrayOfJP_VisaOptionVisaOptionItem), var_export($arrayOfJP_VisaOptionVisaOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VisaOption property can only contain items of type \StructType\JP_VisaOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VisaOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaOption[] $visaOption
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public function setVisaOption(array $visaOption = array())
    {
        // validation for constraint: array
        if ('' !== ($visaOptionArrayErrorMessage = self::validateVisaOptionForArrayConstraintsFromSetVisaOption($visaOption))) {
            throw new \InvalidArgumentException($visaOptionArrayErrorMessage, __LINE__);
        }
        $this->VisaOption = $visaOption;
        return $this;
    }
    /**
     * Add item to VisaOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaOption $item
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public function addToVisaOption(\StructType\JP_VisaOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_VisaOption) {
            throw new \InvalidArgumentException(sprintf('The VisaOption property can only contain items of type \StructType\JP_VisaOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VisaOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_VisaOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_VisaOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_VisaOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_VisaOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_VisaOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VisaOption
     */
    public function getAttributeName()
    {
        return 'VisaOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
